using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Parallax.Serial.IO;

namespace Parallax.Test_Input
{
	//=========================================================================
	public partial class Form1 : Form
	{
		//=========================================================================
		#region -= declarations =-

		Parallax.Serial.IO.Robot m_objRobot;

		#endregion
		//=========================================================================

		//=========================================================================
		#region -= constructor =-

		//=========================================================================
		public Form1()
		{
			InitializeComponent();

			//----
			this.m_objRobot = new Robot();
			this.m_objRobot.DataReceived += new Robot.RobotDataReceivedEventHandler(m_objRobot_DataReceived);
		}
		//=========================================================================

		#endregion
		//=========================================================================

		//=========================================================================
		#region -= event handlers =-

		//=========================================================================
		private void btnMakeLedBlink_Click(object sender, EventArgs e)
		{
			//---- set our status
			this.lblCurrentStatus.Text = "Sending Instruction to R0b0t";
			//----
			this.m_objRobot.SetNumberOfBlinks(int.Parse(this.lstNumberOfIterations.SelectedItem.ToString()));
		}
		//=========================================================================

		//=========================================================================
		void m_objRobot_DataReceived(Robot robot, System.IO.Ports.SerialDataReceivedEventArgs e)
		{
			//this.lblCurrentStatus.Text = e.ToString();
			CheckForIllegalCrossThreadCalls = false;
			this.lblCurrentStatus.Text = "Response: " + robot.Port.ReadExisting().Replace("\n", "");
			
		}
		//=========================================================================

		#endregion
		//=========================================================================

		//=========================================================================
		#region -= internal methods =-

		//=========================================================================
		protected override void OnClosing(CancelEventArgs e)
		{
			base.OnClosing(e);

			if (this.m_objRobot != null)
			{ this.m_objRobot.Close(); }
		}
		//=========================================================================

		#endregion
		//=========================================================================
	}
	//=========================================================================
}